{-# LANGUAGE DeriveLift #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE StandaloneDeriving #-}
{-# OPTIONS_GHC -Wno-orphans #-} -- TODO: is this actually a good idea

module TiedoteMD.Templates.TH where

import Control.Exception (throwIO)
import Data.FileEmbed
import Language.Haskell.TH.Syntax (Q, Exp, Lift, runIO, lift, Quasi(qAddDependentFile))
import Text.DocLayout (Doc(..))
import Text.DocTemplates.Internal (Variable(..), Pipe(..), Alignment(..), Border(..), Template(..))
import Text.Pandoc (compileTemplate)

import qualified Data.Text as T
import qualified Data.Text.IO as T

import TiedoteMD.Types

deriving instance Lift (Doc T.Text)
deriving instance Lift (Template T.Text)
deriving instance Lift Alignment
deriving instance Lift Border
deriving instance Lift Pipe
deriving instance Lift Variable

mkTemplate :: FilePath -> Q Exp
mkTemplate relativeFile = do
    file <- makeRelativeToProject relativeFile
    qAddDependentFile file
    template <- runIO $ do
        templateOrError <- T.readFile file >>= compileTemplate file
        either (throwIO . TemplateError . T.pack) pure templateOrError :: IO (Template T.Text)
    lift template
